# coding: utf-8

import six

from huaweicloudsdkcore.utils.http_utils import sanitize_for_serialization


class MobvoiConfig:

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    sensitive_list = []

    openapi_types = {
        'app_key': 'str',
        'app_secret': 'str',
        'role_id': 'str'
    }

    attribute_map = {
        'app_key': 'app_key',
        'app_secret': 'app_secret',
        'role_id': 'role_id'
    }

    def __init__(self, app_key=None, app_secret=None, role_id=None):
        """MobvoiConfig

        The model defined in huaweicloud sdk

        :param app_key: 奇妙问应用帐号。
        :type app_key: str
        :param app_secret: 奇妙问应用Secret。
        :type app_secret: str
        :param role_id: 奇妙问角色ID。
        :type role_id: str
        """
        
        

        self._app_key = None
        self._app_secret = None
        self._role_id = None
        self.discriminator = None

        if app_key is not None:
            self.app_key = app_key
        if app_secret is not None:
            self.app_secret = app_secret
        if role_id is not None:
            self.role_id = role_id

    @property
    def app_key(self):
        """Gets the app_key of this MobvoiConfig.

        奇妙问应用帐号。

        :return: The app_key of this MobvoiConfig.
        :rtype: str
        """
        return self._app_key

    @app_key.setter
    def app_key(self, app_key):
        """Sets the app_key of this MobvoiConfig.

        奇妙问应用帐号。

        :param app_key: The app_key of this MobvoiConfig.
        :type app_key: str
        """
        self._app_key = app_key

    @property
    def app_secret(self):
        """Gets the app_secret of this MobvoiConfig.

        奇妙问应用Secret。

        :return: The app_secret of this MobvoiConfig.
        :rtype: str
        """
        return self._app_secret

    @app_secret.setter
    def app_secret(self, app_secret):
        """Sets the app_secret of this MobvoiConfig.

        奇妙问应用Secret。

        :param app_secret: The app_secret of this MobvoiConfig.
        :type app_secret: str
        """
        self._app_secret = app_secret

    @property
    def role_id(self):
        """Gets the role_id of this MobvoiConfig.

        奇妙问角色ID。

        :return: The role_id of this MobvoiConfig.
        :rtype: str
        """
        return self._role_id

    @role_id.setter
    def role_id(self, role_id):
        """Sets the role_id of this MobvoiConfig.

        奇妙问角色ID。

        :param role_id: The role_id of this MobvoiConfig.
        :type role_id: str
        """
        self._role_id = role_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                if attr in self.sensitive_list:
                    result[attr] = "****"
                else:
                    result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        import simplejson as json
        if six.PY2:
            import sys
            reload(sys)
            sys.setdefaultencoding("utf-8")
        return json.dumps(sanitize_for_serialization(self), ensure_ascii=False)

    def __repr__(self):
        """For `print`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MobvoiConfig):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
